//---------------------------------------------------------------------------

#include <vcl.h>
#include <Registry.hpp>
#include <string>

#include "Unit1.h"
#include "Unit2.h"
#include "util.h"
#pragma hdrstop
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  MyThread *clock=new MyThread(true);
  clock->Resume();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

AnsiString GetRegistryValue(AnsiString KeyName, AnsiString ValueName)
{
  AnsiString S="";
  TRegistry *Registry = new TRegistry(KEY_READ);
  try
  {
    Registry->RootKey = HKEY_CURRENT_USER;
    // False because we do not want to create it if it doesn't exist
    Registry->OpenKey(KeyName,false);
    S = Registry->ReadString(ValueName);
  }
  __finally
  {
    delete Registry;
  }
  return S;
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    AnsiString BatWorkDir=GetRegistryValue("\\Software\\RIT\\The Bat!","Working Directory");
    if(BatWorkDir=="")
    {
	Application->MessageBox("Can't read registry values, is The Bat installed?","Error",MB_OK+MB_ICONERROR);
        return;
    }
    AnsiString IniFile=BatWorkDir+"\\ADDRBOOK.INI";

    ifstream inifile (IniFile.c_str());
    if(!inifile.good())
    {
	Application->MessageBox("Can't open The Bat INI file, is The Bat installed?","Error",MB_OK+MB_ICONERROR);
        return;
    }

    string str;
    string book_num="";
    string book_name="";
    vector<string> initxt;

    try
    {
	while(getline(inifile,str))
        {
            initxt.push_back(str);
            if(str.find("Default=",0)!=-1)
                book_num=str;
        }
    }
    catch(ios_base::failure &var)
    {
	Application->MessageBox((char*)var.what(),"Error",MB_OK+MB_ICONERROR);
        return;
    }
    if(book_num=="")
    {
       	Application->MessageBox("Error in The Bat INI file...","Error",MB_OK+MB_ICONERROR);
        return;
    }
    book_num.erase(book_num.find("Default=",0),8);
    book_num="Address Book #"+book_num;
    int book_name_pos=0;
    for(unsigned i=0;i<initxt.size();i++)
    {
       if(initxt[i].find(book_num,0)!=-1)
       {
            book_name=initxt[i];
            book_name_pos=i;
       }
       if(initxt[i].find("Default Book=",0)!=-1)
           initxt[i]="Default Book=5af36edb-D2877C6B-B828DC19";
       if(initxt[i].find("Last Book=",0)!=-1)
           initxt[i]="Last Book=5af36edb-D2877C6B-B828DC19";
    }
    if(book_name=="")
    {
       	Application->MessageBox("Error in The Bat INI file...","Error",MB_OK+MB_ICONERROR);
        return;
    }
    book_name.erase(0,book_name.find("=")+1);

    AnsiString s=UpperCase(book_name.c_str());
    book_name=s.c_str();
    if(book_name!="THEBAT.ABD")
        if(Application->MessageBox("   TheBat.ABD! ?","Warning",MB_OKCANCEL+MB_ICONWARNING))
        {
            book_name="TheBat.ABD";
            initxt[book_name_pos]=book_num+"="+book_name;
            //rewrite .ini
            ofstream outinifile (IniFile.c_str());
            if(!outinifile.good())
            {
	         Application->MessageBox("Can't open The Bat INI file for Writing!","Error",MB_OK+MB_ICONERROR);
                 return;
            }
            for(unsigned i=0;i<initxt.size();i++)
               outinifile<<initxt[i]<<endl;
        }


    book_name=BatWorkDir.c_str()+book_name;

    convert *converter=new convert;
    char *args[]= {"",(char*)book_name.c_str(),"c:\\out.txt"};
    if(converter->init(3,args))
	Application->MessageBox("No input files","Error",MB_OK+MB_ICONERROR);
    else
	if(converter->iswrite())
	{
	    if(converter->loadfromsql())
                Application->MessageBox("Read from SQL fault...","Error",MB_OK+MB_ICONERROR);
	    else
		if(converter->writeto())
                    Application->MessageBox("Write fault...","Error",MB_OK+MB_ICONERROR);
                else
                    Application->MessageBox(" !!!","Success",MB_OK);
	}
	else
	    if(converter->readfrom())
                Application->MessageBox("Read fault...","Error",MB_OK+MB_ICONERROR);
    delete converter;
}
//---------------------------------------------------------------------------

