// *********** util.h ***********
// classes and types definition
// constants are in const.h
// implementation is in util.cpp
#ifndef UTIL_H
#define UTIL_H
#include <iostream>
#include <fstream>
#include <time.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string>
#include <vector>
#include <algorithm>

#ifdef __BCPLUSPLUS__
#include <io.h>
#include <vcl.h>

#include "Unit1.h"
#endif

#include "const.h"
#include "crc.h"
#include "basic.h"

#pragma pack(1)

#define ERROR(code,str) { error (code,str); return code; }

typedef vector<string> Attributes;

typedef vector<string> PlainText;

typedef struct {string name; string surname; string email;} Element;
typedef vector<Element> Elements;

class convert : basic
{
    public:
	convert();
	~convert();
	int init(int, char **);	// use with argc, argv from main()
	int readfrom();		// reads content of file to cout
	int loadfrom();		// reads content of text file
#ifdef __BCPLUSPLUS__
	int loadfromsql();		// reads content of SQL table
#endif
	int writeto();		// writes content to .abd file, use it after loadfrom()
	bool iswrite(void);	// returns action, use after init() only
    private:
	void clearitem(void);		// clears content of attr
	void cleartxt();		// clears content of txt
	void loaditem(char*, int);	// arguments are pointer, size, loads data item

	void loadcontrol(char*, int);	// arguments are pointer, size, loads control item
	int getint(char*,int*,int);
	char* getstr(char*,int*,int*,int);

	bool put(const int,const int);		// handle, number, writes number to file
	bool put(const int,const char*);		// handle, pointer, writes len(pointer), then ponter[]
						// both these functions returns
						// false - sucess, true - error
	void loadgroup(char*, int);	// arguments are pointer, size, loads group item

// functions to print out results
	void printitem();		// prints content of vector<string> attr
	static void print(string);	// prints content of string to cout, used in printitem()
// here comes data
	char* filename;		// storage for .abd file name
	char* infilename;	// input file name storage
	Attributes attr;	// vector to store data in string format (used in readfrom())
	bool action;		// action, false - read, true - write
	PlainText txt;		// place to store input textfile
	Elements emaildb;
};

// here comes TheBat (tm) provided data types

namespace thebat_struct
{
    struct RAddrHeader
    {
	int Sign;
	int Size;
	int NextID;
	int LastChange;
	int Count;
	int Capacity;
	int Reserved[11];
    };

    struct RAddrSector
    {
	unsigned int ID;
	int ChangeID;
	int DataPtr;
	unsigned char XType;
    };

    struct RAddrDataHeader
    {
	int Sign;
	unsigned int ID;
	int Time;
	int ChangeID;
	int Capacity;
	int Size;
	unsigned int CRC;
    };
}
#endif
